; Obsluha A/D prevodnika MCP3201 2-Wire
; - Vypracoval Vladimir Visnovsky

; Hlavne nastavenia
; - Port
.Equ	mcPort = PortD
; - Pin CLK a DATA
.Equ	mcClk  = 1
.Equ	mcData = 0
; Chyba v F.3
; Vystup v XL,XH
; - mcAD_Read

; Skok na koniec kniznice
 Rjmp mcpEnd

 ; Read
 amcp_Read:
 ; Ukludnenie zbernice
 Sbi mcPort		, mcClk
 Delay_us [40000]
 ; Spustrenie /CS
 Cbi mcPort		, mcClk
 Delay_us [1000]
 ; generovanie Clk 16x
 Ldi A		, 16
 acmpLoop:
  ; nacitanie bitu
  RCall acmpReadBite
  Dec A
   Brne acmpLoop  
 Ret
 ; V podobe makra
 .Macro mcAD_Read
  RCall amcp_Read
 .EndMacro 

 ; Clk a nacitanie 
 acmpReadBite:
  ; Dole zbernicu
  Cbi mcPort	, mcClk
  Delay_us [2]
  ; Hore zbernicu
  Sbi mcPort	, mcClk
  ; Nacitanie dat
  In T			, mcPort-2
  Delay_us [2]
  ; Posuv X.15 <- X.0
  Rol XL
  Rol XH
  ; Vlozenie nacitaneho bitu
  Bst T			, mcData
  Bld XL		, 0
 Ret

mcpEnd:
