; Kniznica displeja

 ; Definicie registrov
 .Def  SegCnt	= R21
 .Def  ExtCnt	= R9
 .Def  Seg1		= R13
 .Def  Seg2		= R14
 .Def  Seg3		= R15
 Clr R21
 
 .Equ LedPortAnode	= PortB
 .Equ LedPortCatode	= PortD
 .Equ LedCatode1	= 5
 .Equ LedCatode2	= 4
 .Equ LedCatode3	= 6
 .Equ LedA			= 0
 .Equ LedB			= 2
 .Equ LedC			= 4
 .Equ LedD			= 6
 .Equ LedE			= 7
 .Equ LedF			= 1
 .Equ LedG			= 3
 .Equ LedH			= 5
 
 ; Znakova sada
 ; 0 -9  - 0 az 9
 ; 10-15 - A az F
 .Equ LedCharA		= 10
 .Equ LedCharB		= 11
 .Equ LedCharC		= 12
 .Equ LedCharD		= 13
 .Equ LedCharE		= 14
 .Equ LedCharF		= 15
 ; 16    - Minus
 .Equ LedMinus		= 16
 ; 17    - Minus 1
 .Equ LedMinus1		= 17
 ; 18    - Prazny display
 .Equ LedEmpty		= 18
 ; 26    - R
 .Equ LedCharR		= 26
 ; 27    - H
 .Equ LedCharH		= 27
 ; 28    - U
 .Equ LedCharU		= 28
 
; Preskoc procedury
Rjmp mxEnd

; Obsluha 
 aDisp_Server:
  PushA
   ; Pocitadlo blikania
   Inc ExtCnt
    Bst	ExtCnt	, 7
    Sbrs F		, 6
     Clt
    Bld F		, 7
   ; Pocitadlo segmentov
   Mov T		, SegCnt	; Nacitanie hodnoty
   Inc T					; - Inkrement
   Cpi T		, 3			; - Porovnanie so 3
    Brne amxCntEnd			; -- ak nieje preskoc
    Clr T					; -- Inac vynuluj
   amxCntEnd:
   Mov SegCnt	, T			; - Uloz hodnotu spat
   ; Vypnutie segmentov
   Cbi LedPortCatode	, LedCatode1
   Cbi LedPortCatode	, LedCatode2
   Cbi LedPortCatode	, LedCatode3
   ; vyber segmentu
   ; - 1. sehgment
   Cpi SegCnt	, 0 		; Vyber segmentu
    Brne ads_SC1_End
     ; Vykreslenie znaku
     Mov A		, Seg1		; Nacitanie znaku
     Sbrc F		, 7			; Ked je F.7 - zmaz display
      Ldi  A	, LedEmpty
     RCall aDisp_configure	; Volanie nacitanie znaku
     ; Nacitanie bodky
     Bst Seg1	, 7
     Bld A		, LedH
     ; Vykreslenie zanku
     Out LedPortAnode	, A
     ; Rozsvietenie segmentu
     Sbi LedPortCatode	, LedCatode1
    ads_SC1_End:
   ; - 2. sehgment
   Cpi SegCnt	, 1 		; Vyber segmentu
    Brne ads_SC2_End
     ; Vykreslenie znaku
     Mov A		, Seg2		; Nacitanie znaku
     Sbrc F		, 7			; Ked je F.7 - zmaz display
      Ldi  A	, LedEmpty
     RCall aDisp_configure	; Volanie nacitanie znaku
     ; Nacitanie bodky
     Bst Seg2	, 7
     Bld A		, LedH
     ; Vykreslenie zanku
     Out LedPortAnode	, A
     ; Rozsvietenie segmentu
     Sbi LedPortCatode	, LedCatode2
    ads_SC2_End:
   ; - 3. sehgment
   Cpi SegCnt	, 2 		; Vyber segmentu
    Brne ads_SC3_End
     ; Vykreslenie znaku
     Mov A		, Seg3		; Nacitanie znaku
     Sbrc F		, 7			; Ked je F.7 - zmaz display
      Ldi  A	, LedEmpty
     RCall aDisp_configure	; Volanie nacitanie znaku
     ; Nacitanie bodky
     Bst Seg3	, 7
     Bld A		, LedH
     ; Vykreslenie zanku
     Out LedPortAnode	, A
     ; Rozsvietenie segmentu
     Sbi LedPortCatode	, LedCatode3
    ads_SC3_End:
  PopA
  Reti
  
  ; konfiguracia pinov a prepocet 
  aDisp_configure:
   ; Maska spodnych bytov
   Andi	A		, 0b00011111
   ; Vypocet Adresy
   Address [SegTable]
   Add  ZL		, A
   Adc	ZH		, Nul
   ; Nacitanie dat
   Lpm 	T		, Z
   ; Prehodenie bitov
    Bst T		, 6
    Bld A		, LedA
    Bst T		, 5
    Bld A		, LedB
    Bst T		, 4
    Bld A		, LedC
    Bst T		, 3
    Bld A		, LedD
    Bst T		, 2
    Bld A		, LedE
    Bst T		, 1
    Bld A		, LedF
    Bst T		, 0
    Bld A		, LedG
  Ret
 
 ; Konverzia
 ; Prevod Byte -> DEC
aConvertDec:
 ; Register R3 = 10
 Ldi	T		, 10
 ; Vynulovanie vystupnych registrov
 Clr	Seg3
 Clr	Seg2
 Clr	Seg1
; Slucka konverzie 
aConvertLoop:
 ; Porovnanie vstupnej hodnoty z nulov
 Cpi	A		, 0
 Breq	aConvertEnd 	; Ak nula, tak skok na koniec konverzie
 Dec	A				; Odpocitanie zo vstupnej hodnoty
 ; Pocitadlo desiatkovej sustavy
 ; - Jednotky
 Inc	Seg3
 Cp		Seg3 		, T ; Ak R0 presiahlo 10
  Brne 	aConvertLoop
 ; - Desiatky
 Clr	Seg3			; Vynulovanie jednotiek
 Inc	Seg2
 Cp		Seg2 		, T ; Ak R1 presiahlo 10
  Brne 	aConvertLoop
 ; - Stovky
 Clr	Seg2		    ; Vynulovanie jednotiek
 Inc	Seg1
  Rjmp	aConvertLoop
 ; Koniec konverzie 
 aConvertEnd: 
 Ret
 ; V podobe makra
 .Macro DispNum
  RCall aConvertDec
 .EndMacro 

aTempCorect:
 ; Zistenie priznaku minus (kniznica ds1820)
 Sbrc F		, 1
  Rjmp atc_Minus
 ; Prvy znak je nula
 Cp	 Seg1	, Nul
  Brne atc_Seg_NoNul
   Ldi T	, LedEmpty
   Mov Seg1	, T
 ; Druhy znak je nula  
 Cp	 Seg2	, Nul
  Brne atc_Seg_NoNul
   Ldi T	, LedEmpty
   Mov Seg2	, T     
 atc_Seg_NoNul:
 Ret
 ; Vlajka minus
 atc_Minus:
  Mov T		, Seg1
  Ori T		, 0b00010000
  Mov Seg1	, T
  Ret
 ; V podobe makra
 .Macro DispTemp
  RCall aTempCorect
 .EndMacro 
 
 ; Blikanie displeja
 .Macro Blink_Enable
  Ori F		, 0b01000000
 .EndMacro 
 .Macro Blink_Disable
  Andi F	, 0b10111111
 .EndMacro 
  
 SegTable: 
.DB 0x7E, 0x30, 0x6D, 0x79, 0x33, 0x5B, 0x5F, 0x70, 0x7F, 0x7B, 0x77, 0x1F, 0x4E, 0x3D, 0x4F, 0x47 
.DB 0x01, 0x31, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x37, 0x3E, 0x00, 0x00, 0x00 
;.DB 0xFC, 0x60, 0xDA, 0xF2, 0x66, 0xB6, 0xBE, 0xE0, 0xFE, 0xF6, 0xEE, 0x3E, 0x9C, 0x3A, 0x9E, 0x8E 
;.DB 0xF3, 0x60, 0xB5, 0xF4, 0x66, 0xD6, 0xD7, 0x70, 0xF7, 0x76, 0x77, 0xC7, 0x93, 0x75, 0x97, 0x17 
;.DB 0xE7, 0xC0, 0x6B, 0xE9, 0xCC, 0xAD, 0xAF, 0xE0, 0xEF, 0xED, 0xEE, 0x8F, 0x27, 0xCB, 0x2F, 0x2E 
  
  
; Koniec
mxEnd:
